--  -------------------------
--  Shissu's Game/AvA Booster
--  -------------------------
--
--  (c) im Januar 2014 - Mrz 2017 by @Shissu [EU]
--
--  File: ShissuLUAMemory.lua
--  Zuletzt gendert (Last Update): 19.03.2016
 
local _addon = {}
_addon.Name	= "ShissuPvPBooster"
_addon.Version = "1.2.5.11"
_addon.formattedName	= "|cAFD3FFShissu's|r|ceeeeee Game/AvA Booster|r"
_addon.savedVar = {}
_addon.current = {}
_addon.enabled = false
_addon.core = {}        

_addon.settings = { 
  auto = true,  
  ava = false,   
  level = "1",
}

_addon.vars = { 
  nil,
  nil,
  nil,
  "auto",
  "ava",
  "level",
  nil,
  "PFX_SUPPRESS_DISTANCE_v2",
  "VIEW_DISTANCE",
  "RAIN_WETNESS",
  "COLOR_CORRECTION",
  "CHARACTER_LIGHTING",
  "AMBIENT_OCCLUSION",
  "BLOOM",
  "DEPTH_OF_FIELD",
  "DISTORTION",  
  "GOD_RAYS_v2",
  "CLUTTER_2D",
  "WATER_FOAM",
  "SOFT_ALPHA",
  "DIFFUSE_2_MAPS",
  "NORMAL_MAPS",
  "DETAIL_MAPS",
  "SPECULAR_MAPS",
  nil,
  "PFX_GLOBAL_MAXIMUM",
}

local _lib = Shissu_SuiteManager._lib
local _i18n = Shissu_SuiteManager._i18n[_addon.Name]

-- Einstellungen
_addon.panel = _lib.setPanel("Game/AvA Booster", _addon.formattedName, _addon.Version)
_addon.controls = {
  [1] = {
    type = "title",
    name = "Info",
  }, 
  [2] = {
    type = "description",
    text = _i18n["description"],  
  }, 
  [3] = {
    type = "title",
    name = EsoStrings[SI_KEYBINDINGS_CATEGORY_GENERAL],      
  }, 
  [4] = {
    type = "checkbox",                                                                          
    name = EsoStrings[SI_ACTIVECOMBATTIPSETTING1], 
    tooltip = _i18n["auto_tt"],
    setFunc = function(_, value)  
      _addon.core.setSetting("auto", value)
    end,
  },
  [5] = {
    type = "checkbox",                                                                          
    name = _i18n["ava"],
    tooltip = _i18n["ava_tt"],
    setFunc = function(_, value)  
      _addon.core.setSetting("ava", value)
    end,
  },     
  [6] = {
    type = "combobox",
    name = _i18n["level"],
    tooltip = _i18n["level_tt"],
    items = {"1", "2", "user"},
    standard = "1",
    setFunc = function(_, value)
      _addon.core.setSetting("level", value)
     
     _addon.core.getCurrent()
     _addon.core.switch(value)
     
      zo_callLater(function() _addon.core.setOld() _addon.enabled = false end, 2000) 
    end,
  },                                                   
  [7] = {
    type = "title",
    name = _i18n["user"],
  },                              
  [8] = {
    type = "slider",                                                                          
    name = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_PARTICLE_SUPPRESSION_DISTANCE],
    tooltip = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_PARTICLE_SUPPRESSION_DISTANCE_TOOLTIP], 
    minimum = 0,
    maximum = 100,
    steps = 1,
    setFunc = function(value)  
      _addon.core.setSetting("PFX_SUPPRESS_DISTANCE_v2", value)
    end,
  },   
  [9] = {
    type = "slider",                                                                          
    name = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_VIEW_DISTANCE],            
    tooltop = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_VIEW_DISTANCE_TOOLTIP],
    minimum = 0,
    maximum = 100,
    steps = 1,
    setFunc = function(value)  
      _addon.core.setSetting("VIEW_DISTANCE", value)
    end,
  },     
  [10] = {
    type = "checkbox",                                                                          
    name = _i18n["rain"],
    setFunc = function(_, value)  
      _addon.core.setSetting("RAIN_WETNESS", value)
    end,
  },    
  [11] = {
    type = "checkbox",                                                                          
    name = _i18n["color"],
    setFunc = function(_, value)  
      _addon.core.setSetting("COLOR_CORRECTION", value)
    end,
  },    
  [12] = {
    type = "checkbox",                                                                          
    name = _i18n["light"],
    setFunc = function(_, value)  
      _addon.core.setSetting("CHARACTER_LIGHTING", value)
    end,
  },    
  [13] = {
    type = "checkbox",                                                                          
    name = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_AMBIENT_OCCLUSION],   
    tooltip = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_AMBIENT_OCCLUSION_TOOLTIP],
    setFunc = function(_, value)  
      _addon.core.setSetting("AMBIENT_OCCLUSION", value)
    end,
  },    
  [14] = {
    type = "checkbox",                                                                          
    name = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_BLOOM],   
    tooltip = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_BLOOM_TOOLTIP],    
    setFunc = function(_, value)  
      _addon.core.setSetting("BLOOM", value)
    end,
  },    
  [15] = {
    type = "checkbox",                                                                          
    name = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_DEPTH_OF_FIELD], 
    tooltip = EsoStrings[ SI_GRAPHICS_OPTIONS_VIDEO_DEPTH_OF_FIELD_TOOLTIP], 
    setFunc = function(_, value)  
      _addon.core.setSetting("DEPTH_OF_FIELD", value)
    end,
  },    
  [16] = {
    type = "checkbox",                                                                          
    name = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_DISTORTION],   
    tooltip = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_DISTORTION_TOOLTIP],
    setFunc = function(_, value)  
      _addon.core.setSetting("DISTORTION", value)
    end,
  },    
  [17] = {
    type = "checkbox",                                                                          
    name = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_GOD_RAYS],
    tooltip = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_GOD_RAYS_TOOLTIP],
    setFunc = function(_, value)  
      _addon.core.setSetting("GOD_RAYS_v2", value)
    end,
  },    
  [18] = {
    type = "checkbox",                                                                          
    name = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_CLUTTER_2D],  
    tooltip = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_CLUTTER_2D_TOOLTIP], 
    setFunc = function(_, value)  
      _addon.core.setSetting("CLUTTER_2D", value)
    end,
  },    
  [19] = {
    type = "checkbox",                                                                          
    name = _i18n["water"],
    setFunc = function(_, value)  
      _addon.core.setSetting("WATER_FOAM", value)
    end,
  },    
  [20] = {
    type = "checkbox",                                                                          
    name = _i18n["trans"],
    setFunc = function(_, value)  
      _addon.core.setSetting("SOFT_ALPHA", value)
    end,
  },    
  [21] = {
    type = "checkbox",                                                                          
    name = _i18n["diff"],
    setFunc = function(_, value)  
      _addon.core.setSetting("DIFFUSE_2_MAPS", value)
    end,
  },    
  [22] = {
    type = "checkbox",                                                                          
    name = "Normal Mapping",
    setFunc = function(_, value)  
      _addon.core.setSetting("NORMAL_MAPS", value)
    end,
  },    
  [23] = {
    type = "checkbox",                                                                          
    name = "Detail Mapping",
    setFunc = function(_, value)  
      _addon.core.setSetting("DETAIL_MAPS", value)
    end,
  },    
  [24] = {
    type = "checkbox",                                                                          
    name = "Specular Mapping",                           
    setFunc = function(_, value)  
      _addon.core.setSetting("SPECULAR_MAPS", value)
    end,
  },    
  [25] = {
    type = "title",
    name = _i18n["sett"],
  },
  [26] = {
    type = "slider",                                                                          
    name = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_MAXIMUM_PARTICLE_SYSTEMS], 
    tooltip = EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_MAXIMUM_PARTICLE_SYSTEMS_TOOLTIP] .. "|cFF747F" .. EsoStrings[SI_GRAPHICS_OPTIONS_VIDEO_MAXIMUM_PARTICLE_SYSTEMS_RESTRICTION],
    minimum = 0,
    maximum = 2048,
    steps = 1,
    setFunc = function(value)  
      SetCVar("PFX_GLOBAL_MAXIMUM", value)
    end,
  },   
}

-- Speichern / Auslesen / Anwenden von einzelnen Einstellungen
function _addon.core.setCVar(bool)
  for varId=8, 22, 1 do
    SetCVar(_addon.vars[varId], bool)
  end 
end     

function _addon.core.switch(level)
  if _addon.enabled == true then
    _addon.core.setOld()
     _addon.enabled = false
    return
  end
  
  _addon.core.getCurrent()
   
  if ( level == "user" ) then
    for varId=8, 24, 1 do
      SetCVar(var, _addon.savedVar[var] or 0)    
    end    
    
    return
  end
  
  _addon.core.setCVar(0)
  
  if level == 2 then
    SetCVar("PFX_SUPPRESS_DISTANCE_v2", 0)
    SetCVar("VIEW_DISTANCE", 0)
  else
    SetCVar("PFX_SUPPRESS_DISTANCE_v2", 768)
    SetCVar("VIEW_DISTANCE", 10) 
  end 

  _addon.enabled = true
end

function _addon.core.setSetting(var, bool)  
    if value == true then
      SetCVar(var, 1)       
      zo_callLater(function() SetCVar(var, 0) end, 2000);                     
    else
      SetCVar(var, 0)
      zo_callLater(function() SetCVar(var, 1) end, 2000);       
    end 
    
   _addon.settings[var] = bool
   _addon.savedVar[var] = bool     
end
                              
function _addon.core.getSetting(id, var) 
  if _addon.savedVar[var] ~= nil then
    --d(".settings." .. var .. "--: " .. tostring(_addon.savedVar[var]))
    _addon.settings[var] = _addon.savedVar[var]
    
    if id ~= nil then
      Shissu_SuiteManager._settings[_addon.Name]["controls"][id].getFunc = _addon.savedVar[var]  
    end
  elseif _addon.settings[var] ~= nil and id ~= nil then
    Shissu_SuiteManager._settings[_addon.Name]["controls"][id].getFunc = _addon.settings[var] 
  end
end

function _addon.core.slashCommand(what)
  local switch = _lib.switch
  local case = _lib.case
  local default = _lib.default

  _lib.switch(what, 
    case("reset", function() 
      _lib.sendToChat(_addon.formattedName, {"RESET", ""})
      _addon.core.setCVar(1)
    end),
    case("1", function()
      _lib.sendToChat(_addon.formattedName, {"Level 1", ""})
      _addon.core.switch(1)
    end),
    case("2", function()
      _lib.sendToChat(_addon.formattedName, {"Level 2", ""})
      _addon.core.switch(2)
    end),
    case("user", function()
      _lib.sendToChat(_addon.formattedName, {"RESET", ""})
      _addon.core.switch("user")
    end),
    default(function()
      local usage = "USAGE: /slm reset||| 1 |||| 2 |||user" 
      _lib.sendToChat(_addon.formattedName, {usage, ""})
    end) 
  )
end         

function _addon.core.getCurrent()
  for varId=8, 24, 1 do
    _addon.current[_addon.vars[varId]] = GetCVar(_addon.vars[varId])
  end
end

function _addon.core.setOld()
  for varId= 8, 24, 1 do
    SetCVar(_addon.vars[varId], _addon.current[_addon.vars[varId]])
  end
end

-- Ausfhrungen je nach Nutzung /& Konfiguration
function _addon.core.enabled()
--  _addon.core.getCurrent()
--  _addon.enabled = true
  _addon.core.switch(_addon.settings.level)    
end

function _addon.core.disabled()
  _addon.enabled = false
  _addon.core.setOld()
end

function _addon.core.toogle() 
  if (_addon.enabled == false) then
    _addon.core.switch(_addon.settings.level)        
    _lib.sendToChat(_addon.formattedName, {EsoStrings[SI_ADDONLOADSTATE2], ""})
  else
    _addon.core.disabled()
    _lib.sendToChat(_addon.formattedName, {EsoStrings[SI_ADDONLOADSTATE3], ""})
  end
end                                                                                                              

function _addon.core.EVENT_PLAYER_COMBAT_STATE(eventCode, inCombat)
  local inCombat = inCombat
  local isAvA = IsInAvAZone()
  --local isImperial = IsInImperialCity() 
  
  if _addon.settings.auto == true then
    if inCombat and _addon.enabled == false then
      if _addon.settings["ava"] == true and not isAvA then return end --and not isImperial then return end
      _addon.core.switch(_addon.settings.level)        
    else      
      _addon.core.disabled()
    end
  end     
end
         
function _addon.core.initialized()
  _addon.savedVar = shissuGameBooster
                                                          
  for varId=1, #_addon.vars, 1 do
    _addon.core.getSetting(varId, _addon.vars[varId])
  end
                                  
  Shissu_SuiteManager._commands[_addon.Name] = {} 
  table.insert(Shissu_SuiteManager._commands[_addon.Name], { "sab" , _addon.core.slashCommand })
                                                                  
  zo_callLater(function()      
    EVENT_MANAGER:RegisterForEvent(_addon.Name, EVENT_PLAYER_COMBAT_STATE, _addon.core.EVENT_PLAYER_COMBAT_STATE)
    _lib.sendToChat(_addon.formattedName, {"|ceeeeee" .. _addon.Version, ""})
  end, 2000); 
end

-- Initialize Event            
function _addon.EVENT_ADD_ON_LOADED(_, addOnName)
  if addOnName ~= _addon.Name then return end
  
  shissuGameBooster = shissuGameBooster or {}

  zo_callLater(function()                            
    Shissu_SuiteManager.InitializedAddon(_addon.Name)    
  end, 500); 
  
  EVENT_MANAGER:UnregisterForEvent(_addon.Name, EVENT_ADD_ON_LOADED)
end

Shissu_SuiteManager._settings[_addon.Name] = {}
Shissu_SuiteManager._settings[_addon.Name].panel = _addon.panel                                       
Shissu_SuiteManager._settings[_addon.Name].controls = _addon.controls 
Shissu_SuiteManager._init[_addon.Name] = _addon.core.initialized                                        

Shissu_SuiteManager._bindings[_addon.Name] = {}
Shissu_SuiteManager._bindings[_addon.Name].toogle = _addon.core.toogle
ZO_CreateStringId("SI_BINDING_NAME_SAB_Toogle", "Toogle")   

EVENT_MANAGER:RegisterForEvent(_addon.Name, EVENT_ADD_ON_LOADED, _addon.EVENT_ADD_ON_LOADED)